searchNodes=[{"doc":"Config struct. Keys :session_ttl, :refresh_token_ttl and :session_store_module have no defaults and are mandatory. Setting :session_ttl to nil means sessions can live forever, as long as they are refreshed. The token salts serve to separate one token from another, the real secret is the endpoint&#39;s secret key base. Defaults: %Config{ :refresh_token_ttl, # max age of a refresh token :session_store_module, # an implementation of YipyipExAuth.SessionStore :session_ttl, # max age of a session, nil is infinite access_token_ttl: 1800, # max age of an access token access_token_salt: &quot;access_token&quot;, # &quot;namespace&quot; of the access token refresh_token_salt: &quot;refresh_token&quot;, # &quot;namespace&quot; of the refresh token access_token_key_digest: :sha256, # hashing algorithm of the access token refresh_token_key_digest: :sha512, # hashing algorithm of the refresh token access_cookie_name: &quot;_access_token_signature&quot;, # name of the access token&#39;s signature cookie refresh_cookie_name: &quot;_refresh_token_signature&quot;, # name of the refresh token&#39;s signature cookie access_cookie_opts: [ # access cookie opts for Plug.Conn.put_resp_cookie/4 http_only: true, extra: &quot;SameSite=Strict&quot;, secure: true ], refresh_cookie_opts: [ # refresh cookie opts for Plug.Conn.put_resp_cookie/4 http_only: true, extra: &quot;SameSite=Strict&quot;, secure: true ] }","ref":"YipyipExAuth.Config.html","title":"YipyipExAuth.Config","type":"module"},{"doc":"Build config struct from enumerable (useful for passing in application environment).","ref":"YipyipExAuth.Config.html#from_enum/1","title":"YipyipExAuth.Config.from_enum/1","type":"function"},{"doc":"","ref":"YipyipExAuth.Config.html#t:t/0","title":"YipyipExAuth.Config.t/0","type":"type"},{"doc":"A session.","ref":"YipyipExAuth.Models.Session.html","title":"YipyipExAuth.Models.Session","type":"module"},{"doc":"","ref":"YipyipExAuth.Models.Session.html#t:t/0","title":"YipyipExAuth.Models.Session.t/0","type":"type"},{"doc":"Tokens to be communicated to the client.","ref":"YipyipExAuth.Models.Tokens.html","title":"YipyipExAuth.Models.Tokens","type":"module"},{"doc":"","ref":"YipyipExAuth.Models.Tokens.html#t:t/0","title":"YipyipExAuth.Models.Tokens.t/0","type":"type"},{"doc":"Function plugs to create and delete sessions. create_session/3 can be used in combination with YipyipExAuth.Plugs.ProcessRefreshToken for token refreshing.","ref":"YipyipExAuth.Plugs.html","title":"YipyipExAuth.Plugs","type":"module"},{"doc":"Create or update a session. If a session exists in the conn, the session is updated, otherwise a new one is created. The session is put on the conn by YipyipExAuth.Plugs.ProcessRefreshToken. In both cases, new access / refresh tokens are created and stored in the conn&#39;s private map. The server-side session stored in the session store is created / updated as well. The tokens&#39; signatures are split off and sent as cookies if the session&#39;s token signature transport mechanism is set to :cookie. By default, these are http-only strictly-same-site secure cookies. Optionally, it is possible to store extra payload in the access- and refresh tokens, which can be used to implement things like role-based authorization or forced logout after password change.","ref":"YipyipExAuth.Plugs.html#create_session/5","title":"YipyipExAuth.Plugs.create_session/5","type":"function"},{"doc":"Delete the persistent session identified by the session_id in the access token payload. Note that the access token remains valid until it expires, it is left up to the client to drop the access token. It will no longer be possible to refresh the session, however.","ref":"YipyipExAuth.Plugs.html#delete_session/2","title":"YipyipExAuth.Plugs.delete_session/2","type":"function"},{"doc":"Plug to process access tokens.","ref":"YipyipExAuth.Plugs.ProcessAccessToken.html","title":"YipyipExAuth.Plugs.ProcessAccessToken","type":"module"},{"doc":"Process refresh tokens. The token signature source (bearer or cookie) must match the token_signature_transport specified in the token payload. A refresh token can only be used to refresh a session once. A single refresh token id is stored in the server-side session by create/2 to enforce this.","ref":"YipyipExAuth.Plugs.ProcessRefreshToken.html","title":"YipyipExAuth.Plugs.ProcessRefreshToken","type":"module"},{"doc":"Behaviour definition of a persistent session store, to be implemented by the application. The implementation is expected to handle cleanup of expired entries. Reference Redis implementation (requires Redix and assumes a module has been configured for it according to its documentation): defmodule MyAppWeb.RedisSessionStore do @behaviour YipyipExAuth.SessionStore alias MyApp.Redix @key_prefix &quot;SESSION_STORE_&quot; @impl true def get(session_id, user_id) do [&quot;GET&quot;, session_key(session_id, user_id)] |&gt; Redix.command() |&gt; case do {:ok, session} when not is_nil(session) -&gt; deserialize(session) {:ok, nil} -&gt; nil error -&gt; error end end @impl true def upsert(%{id: session_id, user_id: user_id} = session, ttl) do [&quot;SETEX&quot;, session_key(session_id, user_id), Integer.to_string(ttl), serialize(session)] |&gt; Redix.command() |&gt; case do {:ok, _} -&gt; :ok error -&gt; error end end @impl true def delete(session_id, user_id) do [&quot;DEL&quot;, session_key(session_id, user_id)] |&gt; Redix.command() |&gt; case do {:ok, _} -&gt; :ok error -&gt; error end end def get_all(user_id) do with {:ok, keys} when keys != [] &lt;- find_session_keys(user_id), {:ok, values} &lt;- Redix.command([&quot;MGET&quot; | keys]) do Enum.map(values, &amp;deserialize/1) else {:ok, []} -&gt; [] other -&gt; other end end def delete_all(user_id) do with {:ok, keys} when keys != [] &lt;- find_session_keys(user_id), {:ok, _count} &lt;- Redix.command([&quot;DEL&quot; | keys]) do :ok else {:ok, []} -&gt; :ok other -&gt; other end end ##################### # Private functions # ##################### defp serialize(session), do: :erlang.term_to_binary(session) defp deserialize(binary), do: :erlang.binary_to_term(binary) # keys as IO lists to prevent unnecessary string concatenation overhead defp session_key(session_id, user_id), do: [@key_prefix, &quot;.&quot;, user_id, &quot;.&quot;, session_id] # SCAN is not atomic. New sessions created during the scan may not be found. defp find_session_keys(user_id, scan_iteration \\\\ nil, results \\\\ []) defp find_session_keys(_user_id, &quot;0&quot;, results) do {:ok, Enum.uniq(results)} end defp find_session_keys(user_id, scan_iteration, results) do [&quot;SCAN&quot;, scan_iteration, &quot;MATCH&quot;, session_key(&quot;*&quot;, user_id)] |&gt; Redix.command() |&gt; case do {:ok, [scan_iteration | [partial_results]]} -&gt; find_session_keys(user_id, scan_iteration, partial_results ++ results) error -&gt; error end end end","ref":"YipyipExAuth.SessionStore.html","title":"YipyipExAuth.SessionStore","type":"behaviour"},{"doc":"Delete session with id session_id for user with id user_id. Implementations may choose to ignore user_id, since session_id is unique by itself.","ref":"YipyipExAuth.SessionStore.html#c:delete/2","title":"YipyipExAuth.SessionStore.delete/2","type":"callback"},{"doc":"Get session with id session_id for user with id user_id. Implementations may choose to ignore user_id, since session_id is unique by itself.","ref":"YipyipExAuth.SessionStore.html#c:get/2","title":"YipyipExAuth.SessionStore.get/2","type":"callback"},{"doc":"Insert or update Elixir.YipyipExAuth.Models.Session session, with time-to-live ttl. The session_id and user_id are taken from the session struct. Implementations may choose to ignore user_id, since session_id is unique by itself.","ref":"YipyipExAuth.SessionStore.html#c:upsert/2","title":"YipyipExAuth.SessionStore.upsert/2","type":"callback"},{"doc":"Utility functions, mainly getters and setters for module internals.","ref":"YipyipExAuth.Utils.html","title":"YipyipExAuth.Utils","type":"module"},{"doc":"Get access token payload, if present.","ref":"YipyipExAuth.Utils.html#get_access_token_payload/1","title":"YipyipExAuth.Utils.get_access_token_payload/1","type":"function"},{"doc":"Get auth error, if present.","ref":"YipyipExAuth.Utils.html#get_auth_error/1","title":"YipyipExAuth.Utils.get_auth_error/1","type":"function"},{"doc":"Get refresh token payload, if present.","ref":"YipyipExAuth.Utils.html#get_refresh_token_payload/1","title":"YipyipExAuth.Utils.get_refresh_token_payload/1","type":"function"},{"doc":"Get current session, if present.","ref":"YipyipExAuth.Utils.html#get_session/1","title":"YipyipExAuth.Utils.get_session/1","type":"function"},{"doc":"Get token signature transport mechanism, if present.","ref":"YipyipExAuth.Utils.html#get_token_signature_transport/1","title":"YipyipExAuth.Utils.get_token_signature_transport/1","type":"function"},{"doc":"Get tokens, if present.","ref":"YipyipExAuth.Utils.html#get_tokens/1","title":"YipyipExAuth.Utils.get_tokens/1","type":"function"},{"doc":"Set token signature transport mechanism. Must be one of &quot;bearer&quot;, &quot;cookie&quot;, :bearer or :cookie.","ref":"YipyipExAuth.Utils.html#set_token_signature_transport/2","title":"YipyipExAuth.Utils.set_token_signature_transport/2","type":"function"},{"doc":"YipyipExAuth YipyipExAuth is an opinionated session manager for Elixir based on stateless access- and stateful refresh (Phoenix) tokens aimed at browser- and native clients that communicate with an Elixir API. Problems solved This package attempts to solve the following issues: tokens in LocalStorage are less secure than cookies, given that CSRF can be protected against quite well cookies are limited to 4kB native clients don&#39;t like cookies and just want to use tokens stateless tokens are nice for performance but without tracking any server-side sessions, it is impossible to force a logout Problems NOT (attempted to be) solved This package aims to be (and remain) small. It depends only on Phoenix. Also, we like our flexibility. The following things are left up to the application: user management, registration, password change, confirmation emails etc authentication mechanisms like passwords, one-time passwords, etc authorization infrastructure like definining roles etc CSRF-protection This package DOES lay the groundwork for you to add those things.","ref":"readme.html","title":"YipyipExAuth","type":"extras"},{"doc":"A great many solutions exist for generating tokens to use in API authentication. Not many of these implementations really concern themselves with the security of said tokens in a browser contex; the tokens are sent on their way for the client to deal with. Especially the practice of storing authentication tokens in LocalStorage where they are vulnerable to cross-site scripting (XSS) attack vectors is something that this package tries to tackle. At the same time, cookies have their own drawbacks as well; they max out at 4KB and are vulnerable to cross-site request forgery (CSRF). On the other hand, native clients don&#39;t want to deal with cookies, they just want to shove a bearer token into the authorization header and be done with it. This package is an attempt to have the cake and eat it at the same time, by splitting authentication tokens in two parts. Phoenix tokens (and JWT&#39;s) consist of three parts, basically header.payload.signature. The first two parts are not valid without the signature, and the signature is impossible to generate from the first two parts without the underlying signing key thanks to CryptographyTM. YipyipExAuth allows clients to specify at the creation of a session if they want to receive the signature part of their tokens in a secure, HTTP-only strictly-same-site cookie, or simply as part of the the whole token. Browser clients should use the former, native clients the latter. In case of a successful XSS breach of the web application only the token payloads will be exposed. This idea is inspired by this excellent Medium article by Peter Locke (although there are some differences in implementation). Additionally, YipyipExAuth tries to strike a balance between statelessness and security, by using stateless short-lived access tokens and stateful refresh tokens. A server-side session store is maintained (and can be implemented in whatever DB system you like; genserver, Redis, Postgres or Mnesia can all be used by implementing a simple behaviour). Every time the tokens are refreshed, this database is queried. Depending on your access token TTL, this could be once every half an hour per client. By the time you outgrow a simple Redis cluster, you can hire a team of engineers to scale further.","ref":"readme.html#the-long-version","title":"YipyipExAuth - The long version","type":"extras"},{"doc":"Installation The package can be installed by adding yipyip_ex_auth to your list of dependencies in mix.exs: def deps do [ {:yipyip_ex_auth, &quot;~&gt; 0.1.0-alpha.1&quot;} ] end Documentation Documentation can be found at https://hexdocs.pm/yipyip_ex_auth.","ref":"readme.html#how-to-use","title":"YipyipExAuth - How to use","type":"extras"}]